//---------------------------------------------------------------------------
//
// fXNgbv[eBeB 
//     u    Q v
// 
// Programed by T.Shinohara
// 1999-2002
//
// 2002/01/06 version 2.01.00 \[XJ
// 2002/02/05 version 2.01.01 ȌiEmergencyj̐M
//
//---------------------------------------------------------------------------
#include <windows.h>
#include <process.h>

#include "../3DWindow/3DWindow.h"
#include "../Main/SharedInfo.h"
#include "../Main/MainWnd.h"
#include "../Main/Manager.h"
#include "../Main/MadotateAPI.h"
#include "../Main/Version.h"
#include "../Main/AppInfo.h"
#include "../Main/Option.h"
#include "../AboutDialog/AboutDialog.h"
#include "../Main/MenuID.h"
#include "../GetText/GetText.h"

#include "../Misc/debug.h"
#include "Main.h"
//---------------------------------------------------------------------------
LONG WINAPI MadotateExceptionFilter(struct _EXCEPTION_POINTERS * );
int Main();
static HINSTANCE hInstance;
static HANDLE hThread;
//---------------------------------------------------------------------------
static unsigned __stdcall WMain(void */*param*/)
/*int WINAPI WinMain(
		HINSTANCE hInstance,	// ݂̃CX^X̃nh
		HINSTANCE ,//hPrevInstance,	// ȑÕCX^X̃nh
		LPSTR lpszCmdLine,	// R}h C̃AhX
		int //nCmdShow		// EBhE̕\
	)*/
{
	MadotateLog( "enter WinMain" );
	
	/// ̋Î߂̗Onho^
	SetUnhandledExceptionFilter(MadotateExceptionFilter );
	
	madotate::MAppInfo::Init(hInstance,NULL/*lpszCmdLine*/ );
	
	int rv = Main();
	
	MadotateLog( "exit WinMain" );
	CloseHandle(hThread);
	return rv;
}

//---------------------------------------------------------------------------
/// IȂǂ̗OLb`āȂ~onh
LONG WINAPI MadotateExceptionFilter(
	struct _EXCEPTION_POINTERS * /*ExceptionInfo*/ )
{
	static bool done = false;
	if( done )
		exit(1);
	done = true;
	
	MadotateAPI::Emergency();
	
	MessageBox(0,
#ifdef MTATE_LANG_JPN
		"\󂠂܂񂪁AĂ͋I܂B\n"
		"OK{^ƃG[̎ނ\܂B\n"
		"낵΁AG[󋵂Ȃǂ҂ɒʒmĉB\n"
		"肢͊JɂƖ𗧂Ăł傤B",
#else
		"Sorry, this program will be shutdown by the system.\n"
		"The reason will be shown after pressing the OK button.",
#endif
			madotate::GetVersionInfo().Title,MB_OK);
	
	MadotateLog( "exception!" );
	FLUSH_DEBUG_OUT();
	
	return EXCEPTION_CONTINUE_SEARCH;
}

//---------------------------------------------------------------------------
using namespace madotate;

int Main()
{
	// dNj~
	HANDLE mutex = CreateMutex(NULL,false,"Madotate2Mutex");
	bool crash = GetLastError();
	const madotate::MMtateSharedInfo &info = madotate::GetSharedInfo();
	const madotate::MVersionInfo &ver = madotate::GetVersionInfo();
	if( info.versionNumber != ver.VersionNumber ){
		
		MadotateLog( "boot failed: found different version number."
				"[ me="<<hex<<ver.VersionNumber<<
				", on memory="<<hex<<info.versionNumber<<" ]" );
		
		// Âo[W̑ĂĂ̐ݒ肪NĂ̂ŁA
		// Âo[W̑ĂIĂ炤B
		// ܂́AIɏIĂB
		if( IsWindow(info.hwndMainWindow) ){
			PostMessage(info.hwndMainWindow,
					WM_SYSCOMMAND,(WPARAM)SC_CLOSE,0);
			PostMessage(info.hwndMainWindow,
					WM_SYSCOMMAND,(WPARAM)MTATE_MenuID_CLOSE,0);
		}
		{
			// alpha09̐ݒ_CAOmtate.exeƈꏏɏI
			// ȂB
#ifdef MTATE_LANG_JPN
			HWND wnd = FindWindow("TForm1","Ă̐ݒ");
			if( IsWindow(wnd) ){
				PostMessage(wnd,
						WM_SYSCOMMAND,(WPARAM)SC_CLOSE,0);
			}
#else
			// pŁF
			// "Configure"ł́AĈȊÕEBhEqbg邩mȂ
			// ̂ŁA댯ȂB
#endif
		}
		MessageBox(0,
				GetText(Str_PleaseExitOldVersion),"",MB_OK );
		// ̏ꍇłQ邽߂ɁAIB
		// Ⴆ΋L͋o[WŏĂ̂
		// Ȃ\B
		CloseHandle(mutex);
		return 0;
	}
	if( !mutex || crash ){
		// łɂǂɁgÂȂāhNĂB
		MadotateLog( "boot failed: found running madotate on memory." );
		
		CloseHandle(mutex);
		return 0;
	}
	//
	madotate::MMainWindow &mainWnd = madotate::GetMainWindow();
	static M3DWindowConcreteFactory windowFactory;
	madotate::GetManager().SetWindowFactory(&windowFactory);
	
	try{
		// o[WAbv
		int old_ver = madotate::MAppReg::Version();
		int my_ver = madotate::GetVersionInfo().VersionNumber;
		
		MadotateLog( "old_ver=0x"<<hex<<old_ver );
		MadotateLog( "my_ver=0x"<<hex<<my_ver );
		
		//if( old_ver <= 0x20009 ){
		//	// 20009͍ŏ̉płŁẢƂȂo[WA
		//	// ftHgŎ̉ONB20010̎̉͂ƂȂ
		//	// ̂ŁAIOFFɂĂ炤B
		//	GetOptions().UseAutoEffect(false);
		//	GetOptions().Flash();
		//}
		bool isNewVer = false;
		if( old_ver < my_ver ){
			
			madotate::MAppReg::WriteVersion(my_ver );
			isNewVer = true;
		}
		
		DebugOut( "creating main window." );
		
		mainWnd.Create();
		
		if( isNewVer ){
			// Vo[W߂ċNƂ
			// o[W\B
			mainWnd.AboutDialog().Show();
		}
		
		// bZ[W[v
		while( swinlib::GetApplication().HandleMessage() )
			;
	}catch(const char *msg){
		
		MadotateLog( "C++ exception: "<<msg );
		
		MessageBox(mainWnd.Handle(),
				msg,madotate::GetVersionInfo().Title,MB_OK);
	}catch(...){
		
		MadotateLog( "exception: with no handler" );
		
		MessageBox(mainWnd.Handle(),
				"no handler active",madotate::GetVersionInfo().Title,MB_OK);
	}
	
	CloseHandle(mutex);
	return 0;
}

BOOL Init(void)
{
	hThread = (HANDLE)_beginthreadex(NULL,0,WMain,0,0,NULL);
	return TRUE;
}

void Unload(void)
{
	DWORD ExCode;
	GetExitCodeThread(hThread,&ExCode);
	if (ExCode==STILL_ACTIVE) {
		const madotate::MMtateSharedInfo &info = madotate::GetSharedInfo();
		PostMessage(info.hwndMainWindow, WM_CLOSE, 0, 0);
		WaitForSingleObject(hThread,INFINITE);
	}
}

#ifdef __BORLANDC__
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* /*lpReserved*/)
{
	if (reason == DLL_PROCESS_ATTACH) {hInstance=hinst;}
	return 1;
}
#endif

#if _MSC_VER > 1000
BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD fdwReason, LPVOID /*lpvReserved*/)
{
	if (fdwReason == DLL_PROCESS_ATTACH) {::hInstance=hInstance;}
	return TRUE;
}
#endif